]> git.pld-linux.org Git - packages/mysql.git/blob - mysql.init
report slave status with service mysql status
[packages/mysql.git] / mysql.init
1 #!/bin/sh
2 #
3 # mysql         A very fast and reliable SQL database engine
4 #
5 # chkconfig:    2345 84 25
6 #
7 # description:  A very fast and reliable SQL database engine.
8 #
9 # $Id$
10
11 # Source function library
12 . /etc/rc.d/init.d/functions
13
14 # Get network config
15 . /etc/sysconfig/network
16
17 # Get service config
18 if [ -f /etc/sysconfig/mysql ]; then
19         . /etc/sysconfig/mysql
20 else
21         nls "Error: %s not found" /etc/sysconfig/mysql
22         nls "%s can't be run." MySQL
23         exit 1
24 fi
25
26 if [ -n "$MYSQL_DB_CLUSTERS" ]; then
27         nls "Warning: MYSQL_DB_CLUSTERS is set. It's obsolete. Use %s instead." /etc/mysql/clusters.conf
28 fi
29
30 if [ -f /etc/mysql/clusters.conf ]; then
31         MYSQL_DB_CLUSTERS=$(awk -F= '!/^#/ && /=/{print $2}' /etc/mysql/clusters.conf)
32         if [ -z "$MYSQL_DB_CLUSTERS"  ]; then
33                 nls "Warning: there are no configured clusters."
34         fi
35
36 else
37         nls "Warning: Missing clusters config file %s" /etc/mysql/clusters.conf
38         if [ -z "$MYSQL_DB_CLUSTERS"  ]; then
39                 nls "Warning: there are no configured clusters."
40                 nls "Using default cluster /var/lib/mysql (compatibility mode)"
41                 MYSQL_DB_CLUSTERS=/var/lib/mysql
42         fi
43 fi
44
45
46 # Check that networking is up
47 if is_yes "${NETWORKING}"; then
48         if [ ! -f /var/lock/subsys/network -a "$1" != stop -a "$1" != status -a "$1" != init ]; then
49                 msg_network_down MySQL
50                 exit 1
51         fi
52 else
53         exit 0
54 fi
55
56 action="$1"
57
58 # any db cluster as command line argument?
59 if [ $# -gt 1 ]; then
60         shift
61         # perform action for specified clusters only
62         for a in "$@"; do
63                 # try auto resolving from /etc/mysql/clusters.conf
64                 if [[ "$a" != /* ]]; then
65                         m=$(awk -va="$a" -F= 'substr($0, 1, length(a)) == a {print $1}' /etc/mysql/clusters.conf)
66                         if [ -z "$m" ]; then
67                                 echo >&2 "Cluster name '$a' did not match anything!"
68                                 exit 1
69                         fi
70                         if [ $(echo "$m" | wc -l) -gt 1 ]; then
71                                 echo >&2 "Cluster name '$a' ambiguous:" $m
72                                 exit 1
73                         fi
74                         a=$(awk -va="$a" -F= 'substr($0, 1, length(a)) == a {print $2}' /etc/mysql/clusters.conf)
75                 fi
76                 DB_CLUSTERS="$DB_CLUSTERS $a"
77         done
78 else
79         DB_CLUSTERS="$MYSQL_DB_CLUSTERS"
80 fi
81
82 # global error log, if mysqld.conf hasn't migrated to log-error style
83 MYSQL_ERRLOG=/var/log/mysql/mysqld.log
84 MYSQL_STOP_WAIT_TIME=${MYSQL_STOP_WAIT_TIME:-900}
85
86 #
87 # Useful functions.
88 #
89
90 #
91 # check for mysql status
92 #
93 # arguments:
94 # $1 - db cluster
95 # $2 - start|stop
96 #
97 # sets variables:
98 # MYSQL_STATUS = starting | running | not running | died
99 # MYSQL_PID    = pid of mysqld process
100 #
101 mysqlstatus() {
102         clusterdir="$1"
103         mode="$2"
104         
105         mysqlgetconfig "$clusterdir" status
106
107         MYSQL_STATUS="not running"
108         MYSQL_PID="unknown"
109         MYSQL_PIDFILE_PID=""
110         MYSQL_GREP_PID=""
111
112         if [ -f "$MYSQL_PIDFILE" ]; then
113                 MYSQL_PIDFILE_PID=$(cat "$MYSQL_PIDFILE")
114         fi
115         
116         if [ -n "$MYSQL_PIDFILE_PID" ]; then
117                 MYSQL_PID=$MYSQL_PIDFILE_PID
118                 if [ ! -d "/proc/$MYSQL_PID" ]; then
119                         MYSQL_STATUS="died"
120                         return
121                 elif (grep -qa "$MYSQL_PIDFILE" /proc/$MYSQL_PID/cmdline 2> /dev/null); then
122                         MYSQL_STATUS="running"
123                         return
124                 fi
125         fi
126
127         if [ "$mode" = "start" ]; then
128                 MYSQL_GREP_PID=$(grep -lE "^/usr/sbin/mysqld.*${MYSQL_PIDFILE}" /proc/[0-9]*/cmdline 2> /dev/null | awk -F "/" '{ print $3; exit; }')
129                 if [ -n "$MYSQL_GREP_PID" ]; then
130                         MYSQL_PID=$MYSQL_GREP_PID
131                         if grep -qa "$MYSQL_PIDFILE" /proc/$MYSQL_PID/cmdline 2> /dev/null; then
132                                 if [ -f "$MYSQL_PIDFILE" ]; then
133                                         MYSQL_PIDFILE_PID=$(cat "$MYSQL_PIDFILE")
134                                 fi
135                                 if [ -n "$MYSQL_PIDFILE_PID" ]; then
136                                         MYSQL_PID=$MYSQL_PIDFILE_PID
137                                         MYSQL_STATUS="running"
138                                         return
139                                 else
140                                         MYSQL_STATUS="starting"
141                                         return
142                                 fi
143                         fi
144                 fi
145         fi
146
147         # else default, "not running"
148 }
149
150 # get mysql configuration in variables
151 # MYSQL_CONFIG MYSQL_CLUSTER_DIR
152 # MYSQL_DATA_DIR MYSQL_USER MYSQL_PIDFILE MYSQL_SOCKET MYSQL_PORT MYSQL_BIND_ADDRESS MYSQL_SKIP_NETWORKING MYSQL_LOG_ERROR
153 #
154 # arguments
155 # $1 - db cluster
156 # $2 - status | other
157
158 mysqlgetconfig() {
159         local clusterdir="$1" config_file
160         local mode="$2"
161
162         # emulate old behaviour if only one cluster specified
163         if [ "$clusterdir" = "$MYSQL_DB_CLUSTERS" -a "$clusterdir" = "/var/lib/mysql" -a -f /etc/mysqld.conf ]; then
164                 MYSQL_RA_COMPAT=yes
165                 config_file=/etc/mysqld.conf
166         else
167                 local config=$(awk -F= -vclusterdir="$clusterdir" '!/^#/{ if (clusterdir == $2) print $1}' /etc/mysql/clusters.conf)
168                 if [[ $config = /* ]]; then
169                         config_file="$config"
170                 elif [ -f "/etc/mysql/$config" ]; then
171                         config_file="/etc/mysql/$config"
172                 else
173                         config_file="$clusterdir/mysqld.conf"
174                 fi
175         fi
176
177         MYSQL_CLUSTER_DIR="$clusterdir"
178
179         if [ -z "$config_file" ]; then
180                 nls "Error: Can't find config file for %s cluster" "$clusterdir"
181                 if [ "$mode" = "status" ]; then 
182                         exit 3
183                 else
184                         exit 6
185                 fi
186         else
187                 MYSQL_CONFIG="$config_file"
188         fi
189
190         if [ ! -f "$config_file" ]; then
191                 nls "Error: config file %s not found" "$config_file"
192                 nls "MySQL can't be run. Did you initialize DB by doing \`$0 init'?"
193                 if [ "$mode" = "status" ]; then 
194                         exit 3
195                 else
196                         exit 6
197                 fi
198         fi
199
200         # reset to initial state
201         MYSQL_DATA_DIR= MYSQL_USER= MYSQL_PIDFILE= MYSQL_SOCKET= MYSQL_PORT= MYSQL_BIND_ADDRESS= MYSQL_SKIP_NETWORKING= MYSQL_LOG_ERROR=
202
203         eval `awk -F= '
204         {
205                 # undos
206                 gsub(/\r$/, "");
207
208                 # trim spaces
209                 gsub(/^[\t ]+|[\t ]+$/, "", $1);
210                 gsub(/^[\t ]+|[\t ]+$/, "", $2);
211         }
212
213         # skip comments and empty lines
214         /^[;#]|^ *$/ { next }
215
216         /^[ \t]*\[.*\][ \t]*$/ {
217                 match($0, /\[.*\]/);
218                 section = substr($0, RSTART + 1, RSTART + RLENGTH - 3);
219                 next;
220         }
221
222         section == "mysqld" {
223                 if ($1 == "datadir") {
224                         printf("MYSQL_DATA_DIR=%s;", $2);
225                 } else if ($1 == "user") {
226                         printf("MYSQL_USER=%s;", $2);
227                 } else if ($1 == "pid-file") {
228                         printf("MYSQL_PIDFILE=%s;", $2);
229                 } else if ($1 == "socket") {
230                         printf("MYSQL_SOCKET=%s;", $2);
231                 } else if ($1 == "port") {
232                         printf("MYSQL_PORT=%s;", $2);
233                 } else if ($1 == "bind-address") {
234                         printf("MYSQL_BIND_ADDRESS=%s;", $2);
235                 } else if ($1 == "skip-networking") {
236                         printf("MYSQL_SKIP_NETWORKING=1;");
237                 } else if ($1 == "log-error") {
238                         printf("MYSQL_LOG_ERROR=%s;", $2);
239                 }
240         }
241         ' $config_file`
242
243         # error log not defined in config file. add one
244         if [ -z "$MYSQL_LOG_ERROR" ]; then
245                 MYSQL_LOG_ERROR=$MYSQL_ERRLOG
246         else
247                 # unset, so mysqld would use value from config itself
248                 unset MYSQL_LOG_ERROR
249         fi
250
251         if is_yes "$MYSQL_RA_COMPAT"; then
252                 MYSQL_DATA_DIR_SUB=""
253         else
254                 MYSQL_DATA_DIR_SUB="/mysqldb"
255         fi
256
257         if [ -z "$MYSQL_DATA_DIR" -o "$MYSQL_DATA_DIR" != "${clusterdir}${MYSQL_DATA_DIR_SUB}/db" ]; then
258                 nls "Error: datadir specified in %s should be %s" "$config_file" "$clusterdir${MYSQL_DATA_DIR_SUB}/db"
259                 nls " MySQL can't be run."
260                 exit 6
261         fi
262
263         if [ -z "$MYSQL_PIDFILE" -o "$MYSQL_PIDFILE" != "$clusterdir${MYSQL_DATA_DIR_SUB}/mysql.pid" ]; then
264                 nls "Error: pid-file specified in %s should be %s" "$config_file" "$clusterdir${MYSQL_DATA_DIR_SUB}/mysql.pid"
265                 nls " MySQL can't be run."
266                 exit 6
267         fi
268
269         if [ -z "$MYSQL_USER" ]; then
270                 echo "$(nls 'MySQL user not configured properly')"'!' >&2
271                 nls "Edit %s and configure it." "$config_file" >&2
272                 exit 6
273         fi
274 }
275
276 # start mysql
277 mysqlstart() {
278         local clusterdir="$1"
279         mysqlgetconfig "$clusterdir"
280         if [ ! -d "$MYSQL_DATA_DIR/mysql" ]; then
281                 nls "MySQL cluster %s not initialized." "$clusterdir"
282                 nls "Try \`%s init %s' before start." "$0" "$clusterdir"
283                 exit 6
284         fi
285
286         msg_starting "MySQL $clusterdir"; busy
287         [ -z "$DEFAULT_SERVICE_RUN_NICE_LEVEL" ] && DEFAULT_SERVICE_RUN_NICE_LEVEL=0
288         rm -f "$MYSQL_PIDFILE"
289
290
291         TMPDIR=/tmp nice -n ${SERVICE_RUN_NICE_LEVEL:-$DEFAULT_SERVICE_RUN_NICE_LEVEL} \
292                 /usr/bin/setsid /usr/sbin/mysqld \
293                         --defaults-file=$MYSQL_CONFIG \
294                         --datadir=$MYSQL_DATA_DIR \
295                         --pid-file=$MYSQL_PIDFILE \
296                         ${MYSQL_LOG_ERROR:+--log-error="$MYSQL_LOG_ERROR"} \
297                         $MYSQL_OPTIONS &
298         pid=$!
299
300         sleep 0.1
301         mysqlstatus "$clusterdir" start
302         # it takes longer for mysqld to start and create pidfile if it has to recover innodb transactions
303         if [ "$MYSQL_STATUS" = "starting" ]; then
304                 echo ""
305                 show "Waiting for MySQL to start"
306                 busy
307
308                 # while the pid is running, mysql is starting up
309                 # if the pidfile was created, it started up successfully
310                 # if either case fails we break and report status
311                 while true; do
312                         [ -d /proc/$pid ] || break
313                         [ -f "$MYSQL_PIDFILE" ] && break
314                         sleep 0.2
315                 done
316         fi
317
318         mysqlstatus "$clusterdir" start
319         if [ "$MYSQL_STATUS" = "running" -a "$MYSQL_PID" != "unknown" ]; then
320                 ok
321         elif [ "$MYSQL_STATUS" = "died" ]; then
322                 RETVAL=1
323                 died
324         else
325                 RETVAL=1
326                 fail
327         fi
328 }
329
330 # stop mysql
331 mysqlstop() {
332         local clusterdir="$1"
333         mysqlstatus "$clusterdir" stop
334         msg_stopping "MySQL $clusterdir"
335         busy
336
337         # try graceful shutdown -- send shutdown command
338         # requires mysql_sysadmin user proper privs
339         /usr/bin/mysqladmin --defaults-file=$MYSQL_CONFIG ${MYSQL_SOCKET:+--socket=$MYSQL_SOCKET} shutdown >/dev/null 2>&1
340         mysqlstatus "$clusterdir" stop
341
342         if [ "$MYSQL_PID" != "unknown" ]; then
343                 kill -TERM "$MYSQL_PID" 2> /dev/null
344                 for nr in $(seq 1 $(($MYSQL_STOP_WAIT_TIME*10))); do
345                         [ -d "/proc/$MYSQL_PID" ] || break
346                         sleep 0.1
347                 done
348         fi
349         
350         mysqlstatus "$clusterdir" stop
351         if [ "$MYSQL_STATUS" = "died" ]; then
352                 died
353         elif [ "$MYSQL_STATUS" = "running" -o "$MYSQL_STATUS" = "starting" ]; then
354                 fail
355         else
356                 ok
357         fi
358 }
359
360 # report slave status
361 # uses MYSQL_SOCKET - path to mysql socket
362 slave_status() {
363         # see if slave status can be reported
364         local err=0 slave_status=$(mysql -S $MYSQL_SOCKET -e 'show slave status\G')
365         if [ -z "$slave_status" ]; then
366                 # slave not setup
367                 return
368         fi
369
370         printf "\tSlave Status:\n"
371
372         eval $(echo "$slave_status" | awk -F': ' '/^ *[A-Za-z_]+:/{
373                 k = tolower($1);
374                 v = substr($0, length($1) + 3);
375                 gsub(/\\/, "\\\\\\", v);
376                 gsub(/"/, "\\\"", v);
377                 gsub(/`/, "\\`", v);
378                 gsub(/\$/, "\\$", v);
379                 printf("%s=\"%s\";\n", k, v);
380         }')
381
382         if [ "$slave_io_running" != "Yes" ]; then
383                 printf "\tSlave IO not running\n"
384                 err=1
385         fi
386         if [ "$slave_sql_running" != "Yes" ]; then
387                 printf "\tSlave SQL not running\n"
388                 err=1
389         fi
390
391         if [ "$err" = 1 -a "$last_errno" -gt 0 ]; then
392                 printf "\tERROR $last_errno: $last_error\n"
393         fi
394
395         if [ "$master_log_file" != "$relay_master_log_file" ]; then
396                 printf "\tERROR logfile mismatch ($relay_master_log_file)\n"
397                 err=1
398         fi
399
400         if [ -z "$read_master_log_pos" -o -z "$exec_master_log_pos" ]; then
401                 printf "\tERROR No info about master\n"
402                 err=1
403                 return
404         fi
405
406         diff=$(($read_master_log_pos - $exec_master_log_pos))
407         printf "\tread pos: $read_master_log_pos ($master_log_file) (host: $master_host:$master_port)\n"
408         printf "\texec pos: $exec_master_log_pos\n"
409         printf "\tdiff: $diff\n"
410 }
411
412 #
413 # check for running mysql instances; if any instance is running then
414 # create subsys lock file
415 #
416 mysqlsubsys() {
417         # check for every defined db cluster in sysconfig file
418         for mysqldir in $DB_CLUSTERS; do
419                 mysqlstatus "$mysqldir"
420                 if [ "$MYSQL_STATUS" = "running" ]; then
421                         touch /var/lock/subsys/mysql
422                         return
423                 fi
424         done
425         rm -f /var/lock/subsys/mysql
426 }
427
428 mysqlinit() {
429         local clusterdir="$1"
430
431         if [ -f /etc/mysqld.conf ]; then
432                 nls "Running in \`no cluster compat' mode: can't initialize database."
433                 nls "Move /etc/mysqld.conf away and rerun \`$0 init' (new config will be in $clusterdir)."
434                 exit 1
435         fi
436
437         if [ -f "$clusterdir/mysqld.conf" ]; then
438                 mysqlgetconfig "$clusterdir"
439         else
440                 MYSQL_USER="mysql"
441                 MYSQL_CLUSTER_DIR="$clusterdir"
442                 MYSQL_DATA_DIR="$clusterdir/mysqldb/db"
443                 MYSQL_PIDFILE="$clusterdir/mysqldb/mysql.pid"
444                 MYSQL_SOCKET="$clusterdir/mysqldb/mysql.sock"
445
446                 # this $MYSQL_CONFIG will be created later
447                 MYSQL_CONFIG="$MYSQL_CLUSTER_DIR/mysqld.conf"
448         fi
449
450         show "Initializing cluster %s" "$clusterdir"; started
451
452         # Check if not exist init database
453         if [ -d "$MYSQL_DATA_DIR/mysql" ]; then
454                 nls "Seems that database is initialized now. Remove by hand %s" "$MYSQL_DATA_DIR/mysql"
455                 nls "before initializing database."
456                 nls "For now skipping cluster %s." "$clusterdir"
457                 return
458         fi
459
460         show "Installing MySQL system tables for $MYSQL_DATA_DIR"
461         busy
462         TMP=/tmp TMPDIR=/tmp
463
464         mkdir -p "$MYSQL_DATA_DIR" > /dev/null 2>&1
465         # Using mysql:mysql for MYSQL_CLUSTER_DIR is creating SECURITY hole, root:root is proper
466         chown root:root "$MYSQL_CLUSTER_DIR"
467         chown mysql:mysql "$MYSQL_CLUSTER_DIR/mysqldb" "$MYSQL_DATA_DIR" > /dev/null 2>&1
468         chmod 751 "$MYSQL_CLUSTER_DIR" "$MYSQL_CLUSTER_DIR/mysqldb"
469
470         if [ -f /usr/share/mysql/mysqld.conf -a ! -f "$MYSQL_CLUSTER_DIR/mysqld.conf" ]; then
471             sed -e "
472                 s#\(datadir.*\)=.*#\1= $MYSQL_DATA_DIR#g;
473                 s#\(pid-file.*\)=.*#\1= $MYSQL_PIDFILE#g;
474                 s#\(socket.*\)=.*#\1= $MYSQL_SOCKET#g;
475                 s#@clusterdir@#$MYSQL_CLUSTER_DIR#g;
476                 " /usr/share/mysql/mysqld.conf > "$MYSQL_CLUSTER_DIR/mysqld.conf"
477             chown root:root "$MYSQL_CLUSTER_DIR/mysqld.conf"
478             chmod 640 "$MYSQL_CLUSTER_DIR/mysqld.conf"
479         fi
480
481         if [ ! -e /var/lib/mysql/mysql.sock ] || [ -L /var/lib/mysql/mysql.sock ] && [ -z "$(readlink /var/lib/mysql/mysql.sock)" ]; then
482                 sock=${MYSQL_SOCKET#/var/lib/mysql/} # make it relative if possible
483             ln -s "$sock" /var/lib/mysql/mysql.sock
484         fi
485
486         cat > $MYSQL_DATA_DIR/mysql-init.sql <<-EOF
487                 CREATE DATABASE mysql;
488                 use mysql;
489                 $(cat /usr/share/mysql/mysql_system_tables.sql)
490                 $(sed -e "/@current_hostname/d" /usr/share/mysql/mysql_system_tables_data.sql)
491 EOF
492
493         ok=0
494         /usr/sbin/mysqld \
495                 --defaults-file=$MYSQL_CLUSTER_DIR/mysqld.conf \
496                 --bootstrap \
497                 --skip-grant-tables \
498                 --datadir=$MYSQL_DATA_DIR \
499                 --user=$MYSQL_USER \
500                 --slave-load-tmpdir=$MYSQL_DATA_DIR \
501                 --tmpdir=$MYSQL_DATA_DIR \
502                 --log-error=$MYSQL_ERRLOG \
503                 < $MYSQL_DATA_DIR/mysql-init.sql && ok=1
504         [ -f $MYSQL_DATA_DIR/mysql/host.frm ] || ok=0
505
506         if [ "$ok" = 1 ]; then
507                 rm -f $MYSQL_DATA_DIR/mysql-init.sql
508                 ok
509                 cat << END_OF_MSG
510
511 PLEASE REMEMBER TO SET A PASSWORD FOR THE MySQL USERS!
512 This is done, after starting database, in the order shown,
513 with:
514
515 For 'mysql_sysadmin' (RELOAD and SHUTDOWN privileges):
516 echo "update mysql.user set password=password('newpassword') where user='mysql_sysadmin'; FLUSH PRIVILEGES;" | mysql -u mysql -S $MYSQL_SOCKET
517
518 For 'mysql' user (ALL privileges, DB admin):
519 echo "update mysql.user set password=password('newpassword') where user='mysql'; FLUSH PRIVILEGES;" | mysql -u mysql -S $MYSQL_SOCKET
520
521 NOTE: mysql_sysadmin password should be placed to $MYSQL_CONFIG in
522 mysqladmin section. See the manual for more instructions.
523 (This user is used at logs rotation and server shutdown)
524
525 END_OF_MSG
526                 show "Filling help tables..."
527                 ok=0
528                 ( echo "use mysql;"; cat /usr/share/mysql/fill_help_tables.sql ) | \
529                         /usr/sbin/mysqld \
530                         --defaults-file=$MYSQL_CLUSTER_DIR/mysqld.conf \
531                         --bootstrap \
532                         --skip-grant-tables \
533                         --datadir=$MYSQL_DATA_DIR \
534                         --user=$MYSQL_USER \
535                         --slave-load-tmpdir=$MYSQL_DATA_DIR \
536                         --tmpdir=$MYSQL_DATA_DIR \
537                         --log-error=$MYSQL_ERRLOG \
538                         && ok=1
539                 if [ "$ok" = 1 ]; then
540                         ok
541                 else
542                         cat << END_OF_MSG
543
544 WARNING: HELP FILES ARE NOT COMPLETELY INSTALLED!
545 The "HELP" command might not work properly.
546
547 END_OF_MSG
548                 fi
549         else
550                 fail
551                 cat << END_OF_MSG
552 Installation of grant tables FAILED!
553
554 The initialization SQL script was preserved at $MYSQL_DATA_DIR/mysql-init.sql
555
556 Examine the logs in /var/log/mysql for more information.  You can
557 also try to start the mysqld daemon with:
558
559 /usr/sbin/mysqld --skip-grant &
560
561 You can use the command line tool mysql to connect to the mysql
562 database and look at the grant tables:
563
564 shell> mysql -u mysql mysql
565 mysql> show tables
566
567 Try 'mysqld --help' if you have problems with paths. Setting on
568 logging in $MYSQL_DATA_DIR/mysqld.conf gives you a log in /var/log/mysql/query.log that
569 may be helpful. The latest information about MySQL is available on the
570 web at http://www.mysql.com/.
571
572 Please check PLD Linux ftp site for newer versions of this package.
573
574 Please consult the MySQL manual section: 'Problems running
575 mysql_install_db', and the manual section that describes problems on
576 your OS.  Another information source is the MySQL email archive.
577
578 END_OF_MSG
579                 exit 1
580         fi
581 }
582
583 #
584 # End of useful functions.
585 #
586
587 start() {
588         local mysqldir
589         for mysqldir in $DB_CLUSTERS; do
590                 mysqlstatus "$mysqldir" start
591                 if [ "$MYSQL_STATUS" = "running" ]; then
592                         msg_already_running "MySQL $mysqldir"
593                 else
594                         mysqlstart "$mysqldir"
595                 fi
596         done
597         mysqlsubsys
598 }
599
600 stop() {
601         local mysqldir
602         for mysqldir in $DB_CLUSTERS; do
603                 mysqlstatus "$mysqldir" stop
604                 if [ "$MYSQL_STATUS" = "not running" ]; then
605                         msg_not_running "MySQL $mysqldir"
606                 else
607                         mysqlstop "$mysqldir"
608                 fi
609         done
610         mysqlsubsys
611 }
612
613 condrestart() {
614         if [ ! -f /var/lock/subsys/mysql ]; then
615                 msg_not_running "MySQL"
616                 RETVAL=$1
617                 return
618         fi
619
620         stop
621         start
622 }
623
624 RETVAL=0
625 case "$action" in
626   start)
627         start
628         ;;
629   stop)
630         stop
631         ;;
632   restart)
633         stop
634         start
635         ;;
636   try-restart)
637         condrestart 0
638         ;;
639   force-reload)
640         condrestart 7
641         ;;
642   init)
643         for mysqldir in $DB_CLUSTERS; do
644                 mysqlinit "$mysqldir"
645         done
646         exit $?
647         ;;
648   flush-logs)
649         for mysqldir in $DB_CLUSTERS; do
650             mysqlgetconfig "$mysqldir"
651                 # just if mysqld is really running
652                 if /usr/bin/mysqladmin --defaults-file="$MYSQL_CONFIG" --socket="$MYSQL_SOCKET" ping >/dev/null 2>&1; then
653                         /usr/bin/mysqladmin --defaults-file="$MYSQL_CONFIG" --socket="$MYSQL_SOCKET" flush-logs
654                 fi
655         done
656         ;;
657   status)
658         RETVAL=3
659         for mysqldir in $DB_CLUSTERS; do
660                 mysqlstatus "$mysqldir"
661                 if [ "$MYSQL_STATUS" = "running" ]; then
662                         RETVAL=0
663                         addr=${MYSQL_BIND_ADDRESS:-0.0.0.0}
664                         port=${MYSQL_PORT:-3306}
665                         socket=${MYSQL_SOCKET:-/var/lib/mysql/mysql.sock}
666                         pid=$MYSQL_PID
667                         nls "MySQL cluster %s, pid %s\n" "$mysqldir" "$pid"
668                         [ -z "$MYSQL_SKIP_NETWORKING" ] && nls "\ttcp:%s:%s\n" "$addr" "$port"
669                         nls "\tunix:%s\n" "$socket"
670
671                         MYSQL_SOCKET=$socket slave_status
672
673                         pids="$pids/$MYSQL_PID/"
674                         progress "$MYSQL_STATUS"
675                 else
676                         show "MySQL cluster %s" "$mysqldir"
677                         progress "$MYSQL_STATUS" "$CFAIL"
678                 fi
679                 echo
680         done
681
682         for pid in $(/sbin/pidof mysqld); do
683                 if [[ $pids != */$pid/* ]]; then
684                         running="$running $pid"
685                 fi
686         done
687
688         if [ $# = 1 -a "$running" ]; then
689                 nls "Warning: MySQL Daemon processes not under clusters.conf control:"
690                 # see if we can display their status
691                 for pid in $running; do
692                         datadir=$(cat /proc/$pid/cmdline | tr '\0' '\n' | fgrep -- --datadir=)
693                         datadir=${datadir#--datadir=} # strip --datadir
694                         mysqldir=${datadir%/mysqldb/db} # strip /mysqldb/db
695                         mysqlstatus "$mysqldir"
696                         if [ "$MYSQL_STATUS" = "running" ]; then
697                                 addr=${MYSQL_BIND_ADDRESS:-0.0.0.0}
698                                 port=${MYSQL_PORT:-3306}
699                                 socket=${MYSQL_SOCKET:-/var/lib/mysql/mysql.sock}
700                                 nls "MySQL cluster %s, pid %s\n" "$mysqldir" "$pid"
701                                 [ -z "$MYSQL_SKIP_NETWORKING" ] && nls "\ttcp:%s:%s\n" "$addr" "$port"
702                                 nls "\tunix:%s\n" "$socket"
703
704                                 MYSQL_SOCKET=$socket slave_status
705
706                                 progress "$MYSQL_STATUS"
707                         else
708                                 show "MySQL cluster %s" "$mysqldir"
709                                 progress "$MYSQL_STATUS" "$CFAIL"
710                         fi
711                         echo
712                 done
713         fi
714         ;;
715   *)
716         msg_usage "$0 {start|stop|restart|try-restart|force-reload|init|flush-logs|status}"
717         exit 3
718 esac
719
720 exit $RETVAL
This page took 0.089304 seconds and 4 git commands to generate.